<template>
  <!-- promotion card for only BK8 and Main Theme-->
  <div class="horizontal-promotion-card w-full flex my-2 bg-1 rounded-[8px] overflow-hidden group" v-if="selectedTheme === 'bk8' || selectedTheme === 'main'">
    <div class="w-2/5 h-[216px]">
      <img v-lazy="promotion.ImagePathForDisplay" class="w-[504px] h-full object-cover rounded-l-[8px] group-hover:scale-105 duration-500">
    </div>
    <div class="w-3/5">
      <div class="flex flex-col justify-between h-full p-4">
        <div>
          <p class="text-secondary text-[20px] mb-2 font-bold">{{ promotion.Title }}</p>
          <p v-html="promotion.Remark" class="text-[14px]"></p>
        </div>
        <div class="flex justify-between items-end">
          <div class="flex bk8-btn">
              <el-button class="el-info promo-btn min-w-[120px]" @click="toggleBK8Dialog" 
              :id = "`${ID.PROMOTION_INFO}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
              >{{ $t('more_info').toUpperCase() }}</el-button>
              <template v-if="promotion.PromotionTypeId === 10">
                <el-button 
                   v-if="validateLuckyWheelbutton"
                   @click="onClickSpinNow"
                   class="el-apply promo-btn w-[120px]" 
                   :id = "`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
                >{{ $t('Spin Now') }}</el-button>
              </template>
              <template v-else>
                <el-button 
                   v-if="buttonApplyPromotionEnabled(promotion)"
                   @click="onApplyPromotion(promotion)"
                  :loading="isProcessing && isApplying && !isDialogBK8PromotionVisible"
                  :disabled="isProcessing"
                   class="el-apply promo-btn w-[120px]" 
                   :id = "`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
                >{{ $t('apply') }}</el-button>
                <nuxt-link to="/login" v-if="!authenticated">
                  <el-button class="el-apply promo-btn w-[120px]" 
                  :id = "`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
                  >
                    {{ $t("apply") }}
                  </el-button>
                </nuxt-link>
              </template>
          </div>
          <div>
            <p class="pl-2 --text2">{{ $t('promotion_duration') }}</p>
            <div class="flex">
              <div class="--text2 bg-background2 flex justify-center items-center mt-2 ml-2 rounded-[8px] w-[80px]">{{ $t('from_date') }}</div>
              <div class="--text2 bg-background2 py-[8px] px-[16px] mt-2 ml-2 rounded-[8px]">{{ promotion.StartDateForDisplay }}</div>
            </div>
            <div class="flex">
              <div class="--text2 bg-background2 bg-white flex justify-center items-center mt-2 ml-2 rounded-[8px] w-[80px]">{{ $t('till_date') }}</div>
              <div class="--text2 bg-background2 bg-white py-[8px] px-[16px] mt-2 ml-2 rounded-[8px]">{{ promotion.EndDateForDisplay }}</div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <el-dialog
      width="860px"
      v-model="isDialogBK8PromotionVisible"
      :show-close="false"
      custom-class="promotion-header"
      destroy-on-close
      class="rounded"
      @close="navigateTo('/promotion');"
    >
      <template #title>
        <div class="flex justify-center items-center w-full bg-primary text-white text-[20px] py-2 rounded-t font-bold">{{ promotion.Title }}</div>
        <div class="absolute top-[10px] right-[34px]">
              <font-awesome-icon
                class="text-[27px] x-mark cursor-pointer text-white"
                @click="onCancelDialog"
                icon="xmark"
              />
        </div>
      </template>
      <div class="bk8-dialog-body pb-8">
        <div class="px-10 pt-10 w-full flex ">
            <div class=" w-1/2 h-[168px]">
              <img
                v-lazy="promotion.ImagePathForDisplay"
                class="h-full w-full object-cover"
                alt="..."
              />
            </div>
            <div class="w-1/2 px-4">
              <p class="text-[16px] text-hint mb-2">{{ promotion.DateRangeForDisplay }}</p>
              <p class="text-[20px] text-secondary mb-2 font-bold">{{ promotion.Title }}</p>
              <p class="text-[14px]" style="color: var(--text);" v-html="promotion.Remark"></p>
            </div>
        </div>
        <div class="px-10 py-4 w-full h-[2px]">
          <div class="w-full h-[2px]" style="backgroundColor: var(--primary);"></div>
        </div>
        <div v-if="promotion.Content" v-html="promotion.Content" class="px-10 pb-10"></div>
        <div class="flex justify-center items-center bk8-dialog">
              <el-button class="el-info" @click="onCancelDialog">{{ $t('close') }}</el-button>
              <template v-if="promotion.PromotionTypeId === 10">
                <el-button 
                   v-if="validateLuckyWheelbutton"
                   @click="onClickSpinNow"
                   class="el-apply promo-btn w-[120px]" 
                   :id = "`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
                >{{ $t('Spin Now') }}</el-button>
              </template>
              <template v-else>
                <el-button 
                v-if="buttonApplyPromotionEnabled(promotion)"
                  @click="onApplyPromotion(promotion)"
                  :loading="isProcessing && isApplying"
                  class="el-apply" 
                >{{ $t('apply') }}</el-button>
                <nuxt-link to="/login" v-if="!authenticated">
                  <el-button class="el-apply" 
                  :id = "`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
                  >
                    {{ $t("apply") }}
                  </el-button>
                </nuxt-link>
              </template>
        </div>
      </div>
    </el-dialog>
  </div>
  <div class="horizontal-promotion-card" v-else>
    <div
      class="flex w-full display-card rounded-lg drop-shadow-lg h-60 hover:drop-shadow-xl duration-300 ease-out relative"
      :class="
        isHoverScaleCenter
          ? 'hover:scale-105'
          : 'hover:scale-105 origin-top-left'
      "
    >
      <div
        class="absolute promotion-type-title text-white flex justify-center items-center gap-2"
        :class="checkTypeClass(checkPromotionGroup(promotion.PromotionType))"
      >
        <div
          class="promotion_title"
          :style="checkIconClass(checkPromotionGroup(promotion.PromotionType))"
        ></div>
        {{ checkPromotionGroup(promotion.PromotionType) }}
      </div>
      <div
        id="curved-corner-topleft"
        :class="
          checkTriangleClass(checkPromotionGroup(promotion.PromotionType))
        "
      ></div>
      <div class="w-[40%] flex-auto mt-12 ml-10">
        <div class="promotion-date">
          {{ promotion.DateRangeForDisplay }}
        </div>
        <div
          v-html="promotion.Title"
          class="py-2 overflow-hidden truncate promo-title text-ellipsis"
        ></div>
        <div
          v-html="promotion.Remark"
          class="w-[90%] text-ellipsis overflow-hidden promo-remark"
        ></div>
        <div
          @click="toggleDialog"
          class="flex items-center justify-center mt-5 sport-entry-play-button"
          :id = "`${ID.PROMOTION_INFO}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
        >
          {{ $t("information") }}
        </div>
      </div>
      <div class="promotion-image">
        <img
          class="h-full w-full object-contain"
          :src="promotion.ImagePathForDisplay"
          alt=""
        />
      </div>
    </div>
    <el-dialog
      width="860px"
      v-model="isDialogVisible"
      :show-close="false"
      custom-class="promotion-header"
      destroy-on-close
    >
      <template #title>
        <div class="h-fit">
          <div
            class="absolute promotion-type-title-dialog text-white flex justify-center items-center gap-2"
            :class="
              checkTypeClass(checkPromotionGroup(promotion.PromotionType))
            "
          >
            <div class="px-2 flex gap-4">
            <div
              class="promotion_title mb-[24px] !bg-no-repeat"
              :style="checkIconClass(checkPromotionGroup(promotion.PromotionType))"
            ></div>
            <span class="promotion-tag" style="word-break: break-word;">{{
              checkPromotionGroup(promotion.PromotionType)
            }}</span>
            </div>
          </div>
          <div
            id="curved-corner-topleft-dialog"
            :class="
              checkTriangleClass(checkPromotionGroup(promotion.PromotionType))
            "
          ></div>
          <div class="relative">
            <div class="flex justify-start ml-[224px] items-end">
              <h3
                v-html="promotion.Title"
                class="text-left text-[28px] leading-1 font-bold promotion-title mr-14" style="word-break: break-word;"
              ></h3>
            </div>
            <div class="absolute top-[20px] right-[34px]">
              <font-awesome-icon
                class="text-[27px] x-mark cursor-pointer"
                @click="onCancel"
                icon="xmark"
              />
            </div>
          </div>
        </div>
      </template>
      <div class="px-0 pt-0 pb-[29px] set-overflow">
        <div class="border-top-dialog flex flex-col">
          <div class="promotion-dialog-image">
            <img
              :src="promotion.ImagePathForDisplay"
              class="h-full w-full object-contain"
              alt="..."
            />
          </div>
        </div>
        <div class="body-text pt-[34px] px-[32px] pb-[49px]">
          <el-scrollbar max-height="300px" v-if="promotion.Content.length > 0">
            <div class="content" v-html="promotion.Content" />
          </el-scrollbar>
        </div>
        <div class="flex justify-center mb-4 cancel-button">
          <el-button type="danger" plain round @click="onCancel">{{
            $t("cancel")
          }}</el-button>
          <template v-if="promotion.PromotionTypeId === 10">
            <el-button
              v-if="validateLuckyWheelbutton"
              @click="onClickSpinNow"
              type="primary"
              round
              :id = "`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
              >{{ $t("Spin Now") }}</el-button
            >
          </template>
          <template v-else>
            <el-button
              v-if="buttonApplyPromotionEnabled(promotion)"
              @click="onApplyPromotion(promotion)"
              type="primary"
              round
              :disabled="isProcessing"
              :loading="isProcessing && isApplying"
              :id = "`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
              >{{ $t("apply") }}</el-button
            >
          </template>
        </div>
      </div>
    </el-dialog>
  </div>
</template>
<script lang="ts">
import { defineComponent, PropType, ref } from "vue";
import { IPromotion } from "@/models/promotion/promotion";
import commonHelper from "@/utils/commonHelper";
import { store } from '~~/store';
import { ID } from "~~/utils/constants";

export default defineComponent({
  name: "HorizontalPromotionCard",
  props: {
    promotion: {
      type: Object as PropType<IPromotion>,
      required: true,
    },
    authenticated: {
      type: Boolean,
      default: false,
    },
    checkPromotionGroup: {
      type: Function,
      required: true,
    },
    buttonApplyPromotionEnabled: {
      type: Function,
      required: true,
    },
    onApplyPromotion: {
      type: Function,
      required: true,
    },
    isProcessing: {
      type: Boolean,
      default: false,
    },
    isApplying: {
      type: Boolean,
      default: false,
    },
    isHoverScaleCenter: {
      type: Boolean,
      default: false,
    },
    validateLuckyWheelbutton: {
      type: Boolean,
      required: true,
    },
    onClickSpinNow: {
      type: Function,
      required: true,
    },
  },
  setup(props) {
    const selectedTheme = computed(() => store.state.selectedThemeName);
    const isDialogVisible = ref(false);
    const isDialogBK8PromotionVisible = ref(false);
    const { getAssetImage } = commonHelper;
    const firstDepositIcon = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/promotion/Massage.png"
    )})`;
    const commonIcon = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/promotion/Date.png"
    )})`;
    const rebateIcon = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/promotion/Date.png"
    )})`;
    const checkTypeClass = (type: string) => {
      if (type.toLowerCase() === "common") {
        return "promotion-type-title-common";
      }
      if (type.toLowerCase() === "first deposit") {
        return "promotion-type-title-first-deposit";
      }
      return "promotion-type-title-rebate";
    };
    const checkTriangleClass = (type: string) => {
      if (type.toLowerCase() === "common") {
        return "curved-corner-topleft-common";
      }
      if (type.toLowerCase() === "first deposit") {
        return "curved-corner-topleft-first-deposit";
      }
      return "curved-corner-topleft-rebate";
    };
    const checkIconClass = (type: string) => {
      if (type.toLowerCase() === "common") {
        return `background: ${commonIcon}; background-size: auto; background-repeat: no-repeat;`;
      }
      if (type.toLowerCase() === "first deposit") {
        return `background: ${firstDepositIcon}; background-size: auto; background-repeat: no-repeat;`;
      }
      return `background: ${rebateIcon}; background-size: auto; background-repeat: no-repeat;`;
    };
    const toggleDialog = () => {
      isDialogVisible.value = true;
    };
    const toggleBK8Dialog = () => {
      isDialogBK8PromotionVisible.value = true;
      navigateTo('/promotion/'+props.promotion.Id);
    };
    const onCancel = () => {
      isDialogVisible.value = false;
      router.push("/promotion");
    };
    const router = useRouter();
    const onCancelDialog = () => {
      isDialogBK8PromotionVisible.value = false;
      router.push("/promotion");
    };

    const route = useRoute();
      onMounted(()=>{
        const isTheCurrentPromotion = Number(route.params?.id) === props?.promotion?.Id;
        if (!isTheCurrentPromotion) return;
        isDialogBK8PromotionVisible.value = true;
      });
    watch(
      () => route.params,
      () => {
        isDialogVisible.value = Number(route.params.id) === props.promotion.Id;
      },
      { deep: true, immediate: true }
    );
    return {
      checkTypeClass,
      checkTriangleClass,
      checkIconClass,
      toggleDialog,
      toggleBK8Dialog,
      onCancel,
      onCancelDialog,
      isDialogVisible,
      isDialogBK8PromotionVisible,
      firstDepositIcon,
      commonIcon,
      rebateIcon,
      selectedTheme
    };
  },
});
</script>
<style lang="scss">
:root {
  --promotion-button-background: linear-gradient(
      277.16deg,
      rgba(0, 0, 0, 0.4) 6.37%,
      rgba(0, 0, 0, 0) 94.08%
    ),
    #4176fa;
  --promotion-background: #ffffff;
  --promotion-tag-color: var(--textBtn);
  --promotion-dialog-title-color: #6c7ba8;
  --promotion-line-color: var(--hint);
  --promotion-dialog-width: 800px;
  --promotion-button-text: #ffffff;
  --x-mark-color: #666666;
  --promotion-button-text-active: #cccaca;
  --promotion-dialog-content-color: var(--text2);
}
.horizontal-promotion-card {
  .display-card {
    border-radius: 8px;
    overflow: hidden;
    background: var(--promotion-background);

    .promotion-image {
      width: 560px;
      height: 240px;
    }
    .promotion-date {
      font-weight: 700;
      font-size: 16px;
      line-height: 19px;
      letter-spacing: 0.02em;
      color: var(--primary);
    }
  }
  .el-button.el-button--primary,
  .el-button.el-button--danger.is-plain {
    width: 140px;
  }
  .el-button.el-button--primary {
    background: var(--promotion-button-background) !important;
  }
  .el-overlay-dialog:has(.promotion-header.el-dialog) {
    display: flex;
  }

  .promotion-header {
    .bk8-dialog-body {
      background: var(--background1);
    }
  }
  
  .promotion-header.el-dialog {
    border-radius: 9px;
    --el-dialog-width: var(--promotion-dialog-width);
    --el-dialog-border-radius: 8px;
    background: var(--promotion-background);
    position: relative;
    margin: auto;

    .el-dialog__header {
      word-break: break-all;
      margin-right: 0;
      padding: 0;
    }
    .el-dialog__body {
      padding: 0;
      max-height: 150vw;

      .promotion-title {
        font-weight: 700;
        font-size: 28px;
        line-height: 33px;
        letter-spacing: 0.02em;
        color: var(--promotion-dialog-title-color);
      }
      .promotion-dialog-image {
        width: 860px;
        height: 380px;
        border-radius: 0px 0px 8px 8px;
        overflow: hidden;
      }
    }
    .border-top-dialog {
      margin-top: 16px;
      border-top: 4px solid var(--hint);
    }
    .el-scrollbar {
      max-height: 300px;
      height: auto;

      .el-scrollbar__wrap {
        height: auto;
      }
    }
  }
  .promo-title {
    font-weight: 700;
    font-size: 24px;
    line-height: 28px;
    letter-spacing: 0.02em;
    color: var(--text);
  }
  .promo-remark {
    font-weight: 700;
    font-size: 14px;
    line-height: 20px;
    letter-spacing: 0.04em;
    color: var(--primary);
  }
  .promotion-type-title {
    width: 180px;
    height: 40px;
    border-top-left-radius: 9px;
  }
  .promotion-type-title-common {
    background-image: linear-gradient(
      to right,
      rgb(236 151 18),
      rgb(249 196 77)
    );
  }
  .promotion-type-title-rebate {
    background-image: linear-gradient(
      to right,
      rgb(236 151 18),
      rgb(249 196 77)
    );
  }
  .promotion-type-title-first-deposit {
    background-image: linear-gradient(
      to right,
      rgb(132 220 25),
      rgb(144 230 58)
    );
  }
  .promotion-type-title-dialog {
    width: 180px;
    height: 48px;
    border-top-left-radius: 9px;
    .promotion-tag {
      font-weight: 700;
      font-size: 19.2px;
      color: var(--promotion-tag-color);
      line-height: 23px;
    }
  }
  .promotion_title {
    background-size: contain !important;
    width: 25px;
    height: 25px;
    margin: auto 0;
  }
  .first-deposit_icon {
    background: v-bind("firstDepositIcon");
    background-size: auto;
  }
  .common_icon {
    background: v-bind("commonIcon");
    background-size: auto;
    background-repeat: no-repeat;
  }
  .rebate_icon {
    background: v-bind("rebateIcon");
    background-size: auto;
  }
  #curved-corner-topleft {
    width: 44px;
    height: 40px;
    overflow: hidden;
    position: absolute;
    left: 180px;
    border-style: solid;
    border-width: 40px 44px 0 0;
  }
  .curved-corner-topleft-common {
    border-color: #f9c44d transparent transparent;
  }
  .curved-corner-topleft-first-deposit {
    border-color: #90e63a transparent transparent;
  }
  .curved-corner-topleft-rebate {
    border-color: #f9c44d transparent transparent;
  }
  #curved-corner-topleft-dialog {
    width: 44px;
    height: 48px;
    overflow: hidden;
    position: absolute;
    left: 180px;
    border-style: solid;
    border-width: 48px 44px 0 0;
  }
  .sport-entry-play-button {
    border-radius: 24px;
    background: linear-gradient(
        277.16deg,
        rgba(0, 0, 0, 0.4) 6.37%,
        rgba(0, 0, 0, 0) 94.08%
      ),
      #4176fa;
    background-size: contain;
    width: 140px;
    height: 39px;
    color: #fff;
    cursor: pointer;
    transition: 0.3s ease-in-out;
    font-size: 16px;
  }
}

.el-button.el-info {
  background: var(--secondary);
  border:none;
  color: white;
  margin-right: 8px;
  min-width: 120px;
  width: fit-content;

    span{
      pointer-events: none;
    }
}
.el-button.el-apply {
  background: var(--primary);
  border:none;
  color:white;
     
       span{
         pointer-events: none;
       }
}

.text-secondary {
  color: var(--secondary);
}

.bg-1 {
  background: var(--background1);
}

.bg-primary {
  background: var(--primary);
}

.text-hint {
  color: var(--hint);
}
</style>

<style lang="scss" scoped>
[theme-color="bk8"] {
  .bk8-dialog .el-button{
  width: 160px;
  height: 40px;
  border-radius: 8px;
  font-weight: 700;
 }
 .bk8-btn .el-button{
  min-width: 120px;
  height: 40px;
  border-radius: 8px;
  font-weight: 700;
 }
 .el-apply.is-disabled {
  opacity: 1 !important;
 }
}
</style>